Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QSettings

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.core.QSettings

All Implemented Interfaces:
  QtJambiInterface

    public class QSettings

extends QObject

The `QSettings` class provides persistent platform-independent application settings.

Users normally expect an application to remember its settings (window sizes and positions, options, etc.) across sessions. This information is often stored in the system registry on Windows, and in XML preferences files on Mac OS X. On Unix systems, in the absence of a standard, many applications (including the KDE applications) use INI text files.

`QSettings` is an abstraction around these technologies, enabling you to save and restore application settings in a portable manner. It also supports custom storage formats.

`QSettings`'s API is based on `QVariant`, allowing you to save most value-based types, such as `QString`, `QRect`, and `QImage`, with the minimum of effort.

If all you need is a non-persistent memory-based structure, consider using QMap<`QString`, `QVariant`> instead.

- Basic Usage
- QVariant and GUI Types
- Key Syntax
- Fallback Mechanism
- Restoring the State of a GUI Application
- Accessing Settings from Multiple Threads or Processes Simultaneously
- Platform-Specific Notes

### Basic Usage

When creating a `QSettings` object, you must pass the name of your company or organization as well as the name of your application. For example, if your product is called Star Runner and your company is called MySoft, you would construct the `QSettings` object as follows:

            QSettings settings("MySoft", "Star Runner");

`QSettings` objects can be created either on the stack or on the heap (i.e. using `new`). Constructing and destroying a `QSettings` object is very fast.

If you use `QSettings` from many places in your application, you might want to specify the organization name and the application name using QCoreApplication::setOrganizationName() and QCoreApplication::setApplicationName(), and then use the default `QSettings` constructor:

            QCoreApplication::setOrganizationName("MySoft");
            QCoreApplication::setOrganizationDomain("mysoft.com");
            QCoreApplication::setApplicationName("Star Runner");
            ...
            QSettings settings;

(Here, we also specify the organization's Internet domain. When the Internet domain is set, it is used on Mac OS X instead of the organization name, since Mac OS X applications conventionally use Internet domains to identify themselves. If no domain is set, a fake domain is derived from the organization name. See the Platform-Specific Notes below for details.)

`QSettings` stores settings. Each setting consists of a `QString` that specifies the setting's name (the key) and a `QVariant` that stores the data associated with the key. To write a setting, use `setValue`. For example:

            settings.setValue("editor/wrapMargin", 68);

If there already exists a setting with the same key, the existing value is overwritten by the new value. For efficiency, the changes may not be saved to permanent storage immediately. (You can always call `sync` to commit your changes.)

You can get a setting's value back using `value`:

            int margin = settings.value("editor/wrapMargin").toInt();

If there is no setting with the specified name, `QSettings` returns a null `QVariant` (which can be converted to the integer 0). You can specify another default value by passing a second argument to `value`:

            int margin = settings.value("editor/wrapMargin", 80).toInt();

To test whether a given key exists, call `contains`. To remove the setting associated with a key, call `remove`. To obtain the list of all keys, call `allKeys`. To remove all keys, call `clear`.

### QVariant and GUI Types

Because `QVariant` is part of the `QtCore` library, it cannot provide conversion functions to data types such as `QColor`, `QImage`, and `QPixmap`, which are part of `QtGui`. In other words, there is no `toColor()`, `toImage()`, or `toPixmap()` functions in `QVariant`.

Instead, you can use the QVariant::value() or the qVariantValue() template function. For example:

        QSettings settings("MySoft", "Star Runner");
        QColor color = settings.value("DataPump/bgcolor").value<QColor>();

The inverse conversion (e.g., from `QColor` to `QVariant`) is automatic for all data types supported by `QVariant`, including GUI-related types:

        QSettings settings("MySoft", "Star Runner");
        QColor color = palette().background().color();
        settings.setValue("DataPump/bgcolor", color);

Custom types registered using qRegisterMetaType() and qRegisterMetaTypeStreamOperators() can be stored using `QSettings`.

### Key Syntax

Setting keys can contain any Unicode characters. The Windows registry and INI files use case-insensitive keys, whereas the Carbon Preferences API on Mac OS X uses case-sensitive keys. To avoid portability problems, follow these two simple rules:

1. Always refer to the same key using the same case. For example, if you refer to a key as "text fonts" in one place in your code, don't refer to it as "Text Fonts" somewhere else.
2. Avoid key names that are identical except for the case. For example, if you have a key called "`MainWindow`", don't try to save another key as "mainwindow".
3. Do not use slashes ('/' and '\') in key names; the backslash character is used to separate sub keys (see below). On windows '\' are converted by `QSettings` to '/', which makes them identical.

You can form hierarchical keys using the '/' character as a separator, similar to Unix file paths. For example:

            settings.setValue("mainwindow/size", win->size());
            settings.setValue("mainwindow/fullScreen", win->isFullScreen());
            settings.setValue("outputpanel/visible", panel->isVisible());

If you want to save or restore many settings with the same prefix, you can specify the prefix using `beginGroup` and call `endGroup` at the end. Here's the same example again, but this time using the group mechanism:

            settings.beginGroup("mainwindow");
            settings.setValue("size", win->size());
            settings.setValue("fullScreen", win->isFullScreen());
            settings.endGroup();

            settings.beginGroup("outputpanel");
            settings.setValue("visible", panel->isVisible());
            settings.endGroup();

If a group is set using `beginGroup`, the behavior of most functions changes consequently. Groups can be set recursively.

In addition to groups, `QSettings` also supports an "array" concept. See `beginReadArray` and `beginWriteArray` for details.

### Fallback Mechanism

Let's assume that you have created a `QSettings` object with the organization name MySoft and the application name Star Runner. When you look up a value, up to four locations are searched in that order:

1. a user-specific location for the Star Runner application
2. a user-specific location for all applications by MySoft
3. a system-wide location for the Star Runner application
4. a system-wide location for all applications by MySoft

(See Platform-Specific Notes below for information on what these locations are on the different platforms supported by Qt.)

If a key cannot be found in the first location, the search goes on in the second location, and so on. This enables you to store system-wide or organization-wide settings and to override them on a per-user or per-application basis. To turn off this mechanism, call `setFallbacksEnabled`(false).

Although keys from all four locations are available for reading, only the first file (the user-specific location for the application at hand) is accessible for writing. To write to any of the other files, omit the application name and/or specify QSettings::SystemScope (as opposed to QSettings::UserScope, the default).

Let's see with an example:

            QSettings obj1("MySoft", "Star Runner");
            QSettings obj2("MySoft");
            QSettings obj3(QSettings::SystemScope, "MySoft", "Star Runner");
            QSettings obj4(QSettings::SystemScope, "MySoft");

The table below summarizes which `QSettings` objects access which location. "X" means that the location is the main location associated to the `QSettings` object and is used both for reading and for writing; "o" means that the location is used as a fallback when reading.

Locations | `obj1` | `obj2` | `obj3` | `obj4`
--- | --- | --- | --- | ---
1. User, Application | X |  |  |
2. User, Organization | o | X |  |
3. System, Application | o |  | X |
4. System, Organization | o | o | o | X

The beauty of this mechanism is that it works on all platforms supported by Qt and that it still gives you a lot of flexibility, without requiring you to specify any file names or registry paths.

If you want to use INI files on all platforms instead of the native API, you can pass QSettings::IniFormat as the first argument to the `QSettings` constructor, followed by the scope, the organization name, and the application name:

            QSettings settings(QSettings::IniFormat, QSettings::UserScope,
                               "MySoft", "Star Runner");

The Settings Editor example lets you experiment with different settings location and with fallbacks turned on or off.

### Restoring the State of a GUI Application

`QSettings` is often used to store the state of a GUI application. The following example illustrates how to use we will use `QSettings` to save and restore the geometry of an application's main window.

        void MainWindow::writeSettings()
        {
            QSettings settings("Moose Soft", "Clipper");

            settings.beginGroup("MainWindow");
            settings.setValue("size", size());
            settings.setValue("pos", pos());
            settings.endGroup();
        }

        void MainWindow::readSettings()
        {
            QSettings settings("Moose Soft", "Clipper");

            settings.beginGroup("MainWindow");
            resize(settings.value("size", QSize(400, 400)).toSize());
            move(settings.value("pos", QPoint(200, 200)).toPoint());
            settings.endGroup();
        }

See Window Geometry for a discussion on why it is better to call QWidget::resize() and QWidget::move() rather than QWidget::setGeometry() to restore a window's geometry.

The `readSettings()` and `writeSettings()` functions must be called from the main window's constructor and close event handler as follows:

        MainWindow::MainWindow()
        {
            ...
            readSettings();
        }

        void MainWindow::closeEvent(QCloseEvent *event)
        {
            if (userReallyWantsToQuit()) {
                writeSettings();
                event->accept();
            } else {
                event->ignore();
            }
        }

See the Application example for a self-contained example that uses `QSettings`.

### Accessing Settings from Multiple Threads or Processes Simultaneously

`QSettings` is reentrant. This means that you can use distinct `QSettings` object in different threads simultaneously. This guarantee stands even when the `QSettings` objects refer to the same files on disk (or to the same entries in the system registry). If a setting is modified through one `QSettings` object, the change will immediately be visible in any other `QSettings` objects that operate on the same location and that live in the same process.

`QSettings` can safely be used from different processes (which can be different instances of your application running at the same time or different applications altogether) to read and write to the same system locations. It uses advisory file locking and a smart merging algorithm to ensure data integrity. Changes performed by another process aren't visible in the current process until `sync` is called.

### Platform-Specific Notes

#### Locations Where Application Settings Are Stored

As mentioned in the Fallback Mechanism section, `QSettings` stores settings for an application in up to four locations, depending on whether the settings are user-specific or system-wide and whether the the settings are application-specific or organization-wide. For simplicity, we're assuming the organization is called MySoft and the application is called Star Runner.

On Unix systems, if the file format is `NativeFormat`, the following files are used by default:

1. `$HOME/.config/MySoft/Star Runner.conf`
2. `$HOME/.config/MySoft.conf`
3. `/etc/xdg/MySoft/Star Runner.conf`
4. `/etc/xdg/MySoft.conf`

On Mac OS X versions 10.2 and 10.3, these files are used by default:

1. `$HOME/Library/Preferences/com.MySoft.Star Runner.plist`
2. `$HOME/Library/Preferences/com.MySoft.plist`
3. `/Library/Preferences/com.MySoft.Star Runner.plist`
4. `/Library/Preferences/com.MySoft.plist`

On Windows, `NativeFormat` settings are stored in the following registry paths:

1. `HKEY_CURRENT_USER\Software\MySoft\Star Runner`
2. `HKEY_CURRENT_USER\Software\MySoft`
3. `HKEY_LOCAL_MACHINE\Software\MySoft\Star Runner`
4. `HKEY_LOCAL_MACHINE\Software\MySoft`

If the file format is `IniFormat`, the following files are used on Unix and Mac OS X:

1. `$HOME/.config/MySoft/Star Runner.ini`
2. `$HOME/.config/MySoft.ini`
3. `/etc/xdg/MySoft/Star Runner.ini`
4. `/etc/xdg/MySoft.ini`

On Windows, the following files are used:

1. `%APPDATA%\MySoft\Star Runner.ini`
2. `%APPDATA%\MySoft.ini`
3. `%COMMON_APPDATA%\MySoft\Star Runner.ini`
4. `%COMMON_APPDATA%\MySoft.ini`

The `%APPDATA%` path is usually `C:\Documents and Settings\User Name\Application Data`; the `%COMMON_APPDATA%` path is usually `C:\Documents and Settings\All Users\Application Data`.

The paths for the `.ini` and `.conf` files can be changed using `setPath`. On Unix and Mac OS X, the user can override them by by setting the `XDG_CONFIG_HOME` environment variable; see `setPath` for details.

#### Accessing INI and .plist Files Directly

Sometimes you do want to access settings stored in a specific file or registry path. On all platforms, if you want to read an INI file directly, you can use the `QSettings` constructor that takes a file name as first argument and pass QSettings::IniFormat as second argument. For example:

        QSettings settings("/home/petra/misc/myapp.ini",
                           QSettings::IniFormat);

You can then use the `QSettings` object to read and write settings in the file.

On Mac OS X, you can access XML-based `.plist` files by passing QSettings::NativeFormat as second argument. For example:

        QSettings settings("/Users/petra/misc/myapp.plist",
                           QSettings::NativeFormat);

#### Accessing the Windows Registry Directly

On Windows, `QSettings` also lets you access arbitrary entries in the system registry. This is done by constructing a `QSettings` object with a path in the registry and QSettings::NativeFormat. For example:

        QSettings settings("HKEY_CURRENT_USER\\Software\\Microsoft\\Office",
                           QSettings::NativeFormat);

All the registry entries that appear under the specified path can be read or written through the `QSettings` object as usual (using forward slashes instead of backslashes). For example:

        settings.setValue("11.0/Outlook/Security/DontTrustInstalledFiles", 0);

Note that the backslash character is, as mentioned, used by `QSettings` to separate subkeys. As a result, you cannot read or write windows registry entries that contain slashes or backslashes; you should use a native windows API if you need to do so.

#### Accessing Common Registry Settings on Windows

On windows, it is possible for a key to have both a value and subkeys. Its default value is accessed by using "Default" or "." in place of a subkey:

        settings.setValue("HKEY_CURRENT_USER\\MySoft\\Star Runner\\Galaxy", "Milkyway");
        settings.setValue("HKEY_CURRENT_USER\\MySoft\\Star Runner\\Galaxy\\Sun", "OurStar");
        settings.value("HKEY_CURRENT_USER\\MySoft\\Star Runner\\Galaxy\\Default"); // returns "Milkyway"

On other platforms than windows, "Default" and "." would be treated as regular subkeys.

#### Platform Limitations

While `QSettings` attempts to smooth over the differences between the different supported platforms, there are still a few differences that you should be aware of when porting your application:

- The Windows system registry has the following limitations: A subkey may not exceed 255 characters, an entry's value may not exceed 16,383 characters, and all the values of a key may not exceed 65,535 characters. One way to work around these limitations is to store the settings using the `IniFormat` instead of the `NativeFormat`.
- On Mac OS X, `allKeys` will return some extra keys for global settings that apply to all applications. These keys can be read using `value` but cannot be changed, only shadowed. Calling `setFallbacksEnabled`(false) will hide these global settings.
- On Mac OS X, the CFPreferences API used by `QSettings` expects Internet domain names rather than organization names. To provide a uniform API, `QSettings` derives a fake domain name from the organization name (unless the organization name already is a domain name, e.g. OpenOffice.org). The algorithm appends ".com" to the company name and replaces spaces and other illegal characters with hyphens. If you want to specify a different domain name, call QCoreApplication::setOrganizationDomain(), QCoreApplication::setOrganizationName(), and QCoreApplication::setApplicationName() in your `main()` function and then use the default `QSettings` constructor. Another solution is to use preprocessor directives, for example:

          #ifdef Q_WS_MAC
              QSettings settings("grenoullelogique.fr", "Squash");
          #else
              QSettings settings("Grenoulle Logique", "Squash");
          #endif

See Also:
  `QVariant`, `QSessionManager`, `Editor Example`, Application Example

Nested Class Summary
`static class` | `QSettings.Format` This enum type specifies the storage format used by `QSettings`.
`static class` | `QSettings.Scope` This enum specifies whether settings are user-specific or shared by all users of the same system.
`static class` | `QSettings.Status` The following status values are possible.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Constructor Summary
`QSettings()` Equivalent to `QSettings`(0).
`QSettings(QObject parent)` Constructs a `QSettings` object for accessing settings of the application and organization set previously with a call to QCoreApplication::setOrganizationName(), QCoreApplication::setOrganizationDomain(), and QCoreApplication::setApplicationName().
`QSettings(QSettings.Format format, QSettings.Scope scope, java.lang.String organization)` Equivalent to `QSettings`(`format`, `scope`, `organization`, QString(), 0).
`QSettings(QSettings.Format format, QSettings.Scope scope, java.lang.String organization, java.lang.String application)` Equivalent to `QSettings`(`format`, `scope`, `organization`, `application`, 0).
`QSettings(QSettings.Format format, QSettings.Scope scope, java.lang.String organization, java.lang.String application, QObject parent)` Constructs a `QSettings` object for accessing settings of the application called `application` from the organization called `organization`, and with parent `parent`.
`QSettings(QSettings.Scope scope, java.lang.String organization)` Equivalent to `QSettings`(`scope`, `organization`, QString(), 0).
`QSettings(QSettings.Scope scope, java.lang.String organization, java.lang.String application)` Equivalent to `QSettings`(`scope`, `organization`, `application`, 0).
`QSettings(QSettings.Scope scope, java.lang.String organization, java.lang.String application, QObject parent)` Constructs a `QSettings` object for accessing settings of the application called `application` from the organization called `organization`, and with parent `parent`.
`QSettings(java.lang.String organization)` Equivalent to `QSettings`(`organization`, QString(), 0).
`QSettings(java.lang.String fileName, QSettings.Format format)` Equivalent to `QSettings`(`fileName`, `format`, 0).
`QSettings(java.lang.String fileName, QSettings.Format format, QObject parent)` Constructs a `QSettings` object for accessing the settings stored in the file called `fileName`, with parent `parent`.
`QSettings(java.lang.String organization, java.lang.String application)` Equivalent to `QSettings`(`organization`, `application`, 0).
`QSettings(java.lang.String organization, java.lang.String application, QObject parent)` Constructs a `QSettings` object for accessing settings of the application called `application` from the organization called `organization`, and with parent `parent`.

Method Summary
`java.util.List<java.lang.String>` | `allKeys()` Returns a list of all keys, including subkeys, that can be read using the `QSettings` object.
`void` | `beginGroup(java.lang.String prefix)` Appends `prefix` to the current group.
`int` | `beginReadArray(java.lang.String prefix)` Adds `prefix` to the current group and starts reading from an array.
`void` | `beginWriteArray(java.lang.String prefix)` Equivalent to `beginWriteArray`(`prefix`, -1).
`void` | `beginWriteArray(java.lang.String prefix, int size)` Adds `prefix` to the current group and starts writing an array of size `size`.
`java.util.List<java.lang.String>` | `childGroups()` Returns a list of all key top-level groups that contain keys that can be read using the `QSettings` object.
`java.util.List<java.lang.String>` | `childKeys()` Returns a list of all top-level keys that can be read using the `QSettings` object.
`void` | `clear()` Removes all entries in the primary location associated to this `QSettings` object.
`boolean` | `contains(java.lang.String key)` Returns true if there exists a setting called `key`; returns false otherwise.
`void` | `endArray()` Closes the array that was started using `beginReadArray` or `beginWriteArray`.
`void` | `endGroup()` Resets the group to what it was before the corresponding `beginGroup` call.
`boolean` | `event(QEvent event)` This function is reimplemented for internal reasons.
`boolean` | `fallbacksEnabled()` Returns true if fallbacks are enabled; returns false otherwise.
`java.lang.String` | `fileName()` Returns the path where settings written using this `QSettings` object are stored.
`static QSettings` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QSettings instance pointed to by nativePointer
`java.lang.String` | `group()` Returns the current group.
`boolean` | `isWritable()` Returns true if settings can be written using this `QSettings` object; returns false otherwise.
`void` | `remove(java.lang.String key)` Removes the setting `key` and any sub-settings of `key`.
`void` | `setArrayIndex(int i)` Sets the current array index to `i`.
`void` | `setFallbacksEnabled(boolean b)` Sets whether fallbacks are enabled to `b`.
`static void` | `setPath(QSettings.Format format, QSettings.Scope scope, java.lang.String path)` Sets the path used for storing settings for the given `format` and `scope`, to `path`.
`void` | `setValue(java.lang.String key, java.lang.Object value)` Sets the value of setting `key` to `value`.
`QSettings.Status` | `status()` Returns a status code indicating the first error that was met by `QSettings`, or QSettings::NoError if no error occurred.
`void` | `sync()` Writes any unsaved changes to permanent storage, and reloads any settings that have been changed in the meantime by another application.
`java.lang.Object` | `value(java.lang.String key)` Equivalent to value(`key`, QVariant()).
`java.lang.Object` | `value(java.lang.String key, java.lang.Object defaultValue)` Returns the value for setting `key`.

Methods inherited from class com.trolltech.qt.core.QObject
`blockSignals, childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, property, removeEventFilter, setObjectName, setParent, setProperty, signalsBlocked, startTimer, thread, timerEvent`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`disconnect, disconnect, signalSender`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QSettings

    public QSettings()

  Equivalent to `QSettings`(0).

### QSettings

    public QSettings(QObject parent)

  Constructs a `QSettings` object for accessing settings of the application and organization set previously with a call to QCoreApplication::setOrganizationName(), QCoreApplication::setOrganizationDomain(), and QCoreApplication::setApplicationName().

  The scope is QSettings::UserScope and the format is QSettings::NativeFormat.

  The code

          QSettings settings("Moose Soft", "Facturo-Pro");

  is equivalent to

          QCoreApplication::setOrganizationName("Moose Soft");
          QCoreApplication::setApplicationName("Facturo-Pro");
          QSettings settings;

  If QCoreApplication::setOrganizationName() and QCoreApplication::setApplicationName() has not been previously called, the `QSettings` object will not be able to read or write any settings, and `status` will return `AccessError`.

  On Mac OS X, if both a name and an Internet domain are specified for the organization, the domain is preferred over the name. On other platforms, the name is preferred over the domain.

  See Also:
    `QCoreApplication::setOrganizationName`, `QCoreApplication::setOrganizationDomain`, `QCoreApplication::setApplicationName`

### QSettings

    public QSettings(java.lang.String organization,
                     java.lang.String application)

  Equivalent to `QSettings`(`organization`, `application`, 0).

### QSettings

    public QSettings(java.lang.String organization)

  Equivalent to `QSettings`(`organization`, QString(), 0).

### QSettings

    public QSettings(java.lang.String organization,
                     java.lang.String application,
                     QObject parent)

  Constructs a `QSettings` object for accessing settings of the application called `application` from the organization called `organization`, and with parent `parent`.

  Example:

          QSettings settings("Moose Tech", "Facturo-Pro");

  The scope is QSettings::UserScope and the format is QSettings::NativeFormat.

  See Also:
    Fallback Mechanism

### QSettings

    public QSettings(QSettings.Format format,
                     QSettings.Scope scope,
                     java.lang.String organization,
                     java.lang.String application)

  Equivalent to `QSettings`(`format`, `scope`, `organization`, `application`, 0).

### QSettings

    public QSettings(QSettings.Format format,
                     QSettings.Scope scope,
                     java.lang.String organization)

  Equivalent to `QSettings`(`format`, `scope`, `organization`, QString(), 0).

### QSettings

    public QSettings(QSettings.Format format,
                     QSettings.Scope scope,
                     java.lang.String organization,
                     java.lang.String application,
                     QObject parent)

  Constructs a `QSettings` object for accessing settings of the application called `application` from the organization called `organization`, and with parent `parent`.

  If `scope` is QSettings::UserScope, the `QSettings` object searches user-specific settings first, before it searches system-wide settings as a fallback. If `scope` is QSettings::SystemScope, the `QSettings` object ignores user-specific settings and provides access to system-wide settings.

  If `format` is QSettings::NativeFormat, the native API is used for storing settings. If `format` is QSettings::IniFormat, the INI format is used.

  If no application name is given, the `QSettings` object will only access the organization-wide locations.

### QSettings

    public QSettings(QSettings.Scope scope,
                     java.lang.String organization,
                     java.lang.String application)

  Equivalent to `QSettings`(`scope`, `organization`, `application`, 0).

### QSettings

    public QSettings(QSettings.Scope scope,
                     java.lang.String organization)

  Equivalent to `QSettings`(`scope`, `organization`, QString(), 0).

### QSettings

    public QSettings(QSettings.Scope scope,
                     java.lang.String organization,
                     java.lang.String application,
                     QObject parent)

  Constructs a `QSettings` object for accessing settings of the application called `application` from the organization called `organization`, and with parent `parent`.

  If `scope` is QSettings::UserScope, the `QSettings` object searches user-specific settings first, before it searches system-wide settings as a fallback. If `scope` is QSettings::SystemScope, the `QSettings` object ignores user-specific settings and provides access to system-wide settings.

  The storage format is always QSettings::NativeFormat.

  If no application name is given, the `QSettings` object will only access the organization-wide locations.

### QSettings

    public QSettings(java.lang.String fileName,
                     QSettings.Format format)

  Equivalent to `QSettings`(`fileName`, `format`, 0).

### QSettings

    public QSettings(java.lang.String fileName,
                     QSettings.Format format,
                     QObject parent)

  Constructs a `QSettings` object for accessing the settings stored in the file called `fileName`, with parent `parent`. If the file doesn't already exist, it is created.

  If `format` is QSettings::NativeFormat, the meaning of `fileName` depends on the platform. On Unix, `fileName` is the name of an INI file. On Mac OS X, `fileName` is the name of a `.plist` file. On Windows, `fileName` is a path in the system registry.

  If `format` is QSettings::IniFormat, `fileName` is the name of an INI file.

  See Also:
    `fileName`

Method Detail

### allKeys

    public final java.util.List<java.lang.String> allKeys()

  Returns a list of all keys, including subkeys, that can be read using the `QSettings` object.

  Example:

          QSettings settings;
          settings.setValue("fridge/color", Qt::white);
          settings.setValue("fridge/size", QSize(32, 96));
          settings.setValue("sofa", true);
          settings.setValue("tv", false);

          QStringList keys = settings.allKeys();
          // keys: ["fridge/color", "fridge/size", "sofa", "tv"]

  If a group is set using `beginGroup`, only the keys in the group are returned, without the group prefix:

          settings.beginGroup("fridge");
          keys = settings.allKeys();
          // keys: ["color", "size"]

  See Also:
    `childGroups`, `childKeys`

### beginGroup

    public final void beginGroup(java.lang.String prefix)

  Appends `prefix` to the current group.

  The current group is automatically prepended to all keys specified to `QSettings`. In addition, query functions such as `childGroups`, `childKeys`, and `allKeys` are based on the group. By default, no group is set.

  Groups are useful to avoid typing in the same setting paths over and over. For example:

          settings.beginGroup("mainwindow");
          settings.setValue("size", win->size());
          settings.setValue("fullScreen", win->isFullScreen());
          settings.endGroup();

          settings.beginGroup("outputpanel");
          settings.setValue("visible", panel->isVisible());
          settings.endGroup();

  This will set the value of three settings:

  - `mainwindow/size`
  - `mainwindow/fullScreen`
  - `outputpanel/visible`

  Call `endGroup` to reset the current group to what it was before the corresponding `beginGroup` call. Groups can be nested.

  See Also:
    `endGroup`, `group`

### beginReadArray

    public final int beginReadArray(java.lang.String prefix)

  Adds `prefix` to the current group and starts reading from an array. Returns the size of the array.

  Example:

          struct Login {
              QString userName;
              QString password;
          };
          QList<Login> logins;
          ...

          QSettings settings;
          int size = settings.beginReadArray("logins");
          for (int i = 0; i < size; ++i) {
              settings.setArrayIndex(i);
              Login login;
              login.userName = settings.value("userName");
              login.password = settings.value("password");
              logins.append(login);
          }
          settings.endArray();

  Use `beginWriteArray` to write the array in the first place.

  See Also:
    `beginWriteArray`, `endArray`, `setArrayIndex`

### beginWriteArray

    public final void beginWriteArray(java.lang.String prefix)

  Equivalent to `beginWriteArray`(`prefix`, -1).

### beginWriteArray

    public final void beginWriteArray(java.lang.String prefix,
                                      int size)

  Adds `prefix` to the current group and starts writing an array of size `size`. If `size` is -1 (the default), it is automatically determined based on the indexes of the entries written.

  If you have many occurrences of a certain set of keys, you can use arrays to make your life easier. For example, let's suppose that you want to save a variable-length list of user names and passwords. You could then write:

          struct Login {
              QString userName;
              QString password;
          };
          QList<Login> logins;
          ...

          QSettings settings;
          settings.beginWriteArray("logins");
          for (int i = 0; i < logins.size(); ++i) {
              settings.setArrayIndex(i);
              settings.setValue("userName", list.at(i).userName);
              settings.setValue("password", list.at(i).password);
          }
          settings.endArray();

  The generated keys will have the form

  - `logins/1/userName`
  - `logins/1/password`
  - `logins/2/userName`
  - `logins/2/password`
  - `logins/3/userName`
  - `logins/3/password`
  - ...

  To read back an array, use `beginReadArray`.

  See Also:
    `beginReadArray`, `endArray`, `setArrayIndex`

### childGroups

    public final java.util.List<java.lang.String> childGroups()

  Returns a list of all key top-level groups that contain keys that can be read using the `QSettings` object.

  Example:

          QSettings settings;
          settings.setValue("fridge/color", Qt::white);
          settings.setValue("fridge/size", QSize(32, 96));
          settings.setValue("sofa", true);
          settings.setValue("tv", false);

          QStringList groups = settings.childGroups();
          // group: ["fridge"]

  If a group is set using `beginGroup`, the first-level keys in that group are returned, without the group prefix.

          settings.beginGroup("fridge");
          groups = settings.childGroups();
          // groups: []

  You can navigate through the entire setting hierarchy using `childKeys` and `childGroups` recursively.

  See Also:
    `childKeys`, `allKeys`

### childKeys

    public final java.util.List<java.lang.String> childKeys()

  Returns a list of all top-level keys that can be read using the `QSettings` object.

  Example:

          QSettings settings;
          settings.setValue("fridge/color", Qt::white);
          settings.setValue("fridge/size", QSize(32, 96));
          settings.setValue("sofa", true);
          settings.setValue("tv", false);

          QStringList keys = settings.childKeys();
          // keys: ["sofa", "tv"]

  If a group is set using `beginGroup`, the top-level keys in that group are returned, without the group prefix:

          settings.beginGroup("fridge");
          keys = settings.childKeys();
          // keys: ["color", "size"]

  You can navigate through the entire setting hierarchy using `childKeys` and `childGroups` recursively.

  See Also:
    `childGroups`, `allKeys`

### clear

    public final void clear()

  Removes all entries in the primary location associated to this `QSettings` object.

  Entries in fallback locations are not removed.

  If you only want to remove the entries in the current `group`, use remove("") instead.

  See Also:
    `remove`, `setFallbacksEnabled`

### contains

    public final boolean contains(java.lang.String key)

  Returns true if there exists a setting called `key`; returns false otherwise.

  If a group is set using `beginGroup`, `key` is taken to be relative to that group.

  See Also:
    `value`, `setValue`

### endArray

    public final void endArray()

  Closes the array that was started using `beginReadArray` or `beginWriteArray`.

  See Also:
    `beginReadArray`, `beginWriteArray`

### endGroup

    public final void endGroup()

  Resets the group to what it was before the corresponding `beginGroup` call.

  Example:

          settings.beginGroup("alpha");
          // settings.group() == "alpha"

          settings.beginGroup("beta");
          // settings.group() == "alpha/beta"

          settings.endGroup();
          // settings.group() == "alpha"

          settings.endGroup();
          // settings.group() == ""

  See Also:
    `beginGroup`, `group`

### fallbacksEnabled

    public final boolean fallbacksEnabled()

  Returns true if fallbacks are enabled; returns false otherwise.

  By default, fallbacks are enabled.

  See Also:
    `setFallbacksEnabled`

### fileName

    public final java.lang.String fileName()

  Returns the path where settings written using this `QSettings` object are stored.

  On Windows, if the format is QSettings::NativeFormat, the return value is a system registry path, not a file path.

  See Also:
    `isWritable`

### group

    public final java.lang.String group()

  Returns the current group.

  See Also:
    `beginGroup`, `endGroup`

### isWritable

    public final boolean isWritable()

  Returns true if settings can be written using this `QSettings` object; returns false otherwise.

  One reason why `isWritable` might return false is if `QSettings` operates on a read-only file.

  Warning: This function is not perfectly reliable, because the file permissions can change at any time.

  See Also:
    `fileName`, `status`, `sync`

### remove

    public final void remove(java.lang.String key)

  Removes the setting `key` and any sub-settings of `key`.

  Example:

          QSettings settings;
          settings.setValue("ape");
          settings.setValue("monkey", 1);
          settings.setValue("monkey/sea", 2);
          settings.setValue("monkey/doe", 4);

          settings.remove("monkey");
          QStringList keys = settings.allKeys();
          // keys: ["ape"]

  Be aware that if one of the fallback locations contains a setting with the same key, that setting will be visible after calling `remove`.

  If `key` is an empty string, all keys in the current `group` are removed. For example:

          QSettings settings;
          settings.setValue("ape");
          settings.setValue("monkey", 1);
          settings.setValue("monkey/sea", 2);
          settings.setValue("monkey/doe", 4);

          settings.beginGroup("monkey");
          settings.remove("");
          settings.endGroup();

          QStringList keys = settings.allKeys();
          // keys: ["ape"]

  See Also:
    `setValue`, `value`, `contains`

### setArrayIndex

    public final void setArrayIndex(int i)

  Sets the current array index to `i`. Calls to functions such as `setValue`, `value`, `remove`, and `contains` will operate on the array entry at that index.

  You must call `beginReadArray` or `beginWriteArray` before you can call this function.

### setFallbacksEnabled

    public final void setFallbacksEnabled(boolean b)

  Sets whether fallbacks are enabled to `b`.

  By default, fallbacks are enabled.

  See Also:
    `fallbacksEnabled`

### setValue

    public final void setValue(java.lang.String key,
                               java.lang.Object value)

  Sets the value of setting `key` to `value`.

  If the key already exists, the previous value is overwritten.

  Example:

          QSettings settings;
          settings.setValue("interval", 30);
          settings.value("interval").toInt();     // returns 30

          settings.setValue("interval", 6.55);
          settings.value("interval").toDouble();  // returns 6.55

  See Also:
    `value`, `remove`, `contains`

### status

    public final QSettings.Status status()

  Returns a status code indicating the first error that was met by `QSettings`, or QSettings::NoError if no error occurred.

### sync

    public final void sync()

  Writes any unsaved changes to permanent storage, and reloads any settings that have been changed in the meantime by another application.

  Unless you use `QSettings` as a communication mechanism between different processes, you normally don't need to call this function.

### value

    public final java.lang.Object value(java.lang.String key)

  Equivalent to value(`key`, QVariant()).

### value

    public final java.lang.Object value(java.lang.String key,
                                        java.lang.Object defaultValue)

  Returns the value for setting `key`. If the setting doesn't exist, returns `defaultValue`.

  If no default value is specified, a default `QVariant` is returned.

  Example:

          QSettings settings;
          settings.setValue("animal/snake", 58);
          settings.value("animal/snake", 1024).toInt();   // returns 58
          settings.value("animal/zebra", 1024).toInt();   // returns 1024
          settings.value("animal/zebra").toInt();         // returns 0

  See Also:
    `setValue`, `contains`, `remove`

### event

    public boolean event(QEvent event)

  This function is reimplemented for internal reasons.

  Overrides:
    `event` in class `QObject`
  See Also:
    `installEventFilter`, `timerEvent`, `QApplication::sendEvent`, `QApplication::postEvent`, `QWidget::event`

### setPath

    public static void setPath(QSettings.Format format,
                               QSettings.Scope scope,
                               java.lang.String path)

  Sets the path used for storing settings for the given `format` and `scope`, to `path`. The `format` can be a custom format.

  The table below summarizes the default values:

  Platform | Format | Scope | Path
  --- | --- | --- | ---
  Windows | `IniFormat` | `UserScope` | `%APPDATA%`
  `SystemScope` | `%COMMON_APPDATA%`
  Unix | `NativeFormat`, `IniFormat` | `UserScope` | `$HOME/.config`
  `SystemScope` | `/etc/xdg`
  Mac OS X | `IniFormat` | `UserScope` | `$HOME/.config`
  `SystemScope` | `/etc/xdg`

  The default `UserScope` paths on Unix and Mac OS X (`$HOME/.config`) can be overridden by the user by setting the `XDG_CONFIG_HOME` environment variable. The default `SystemScope` paths on Unix and Mac OS X (`/etc/xdg`) can be overridden when building the Qt library using the `configure` script's `--sysconfdir` flag (see `QLibraryInfo` for details).

  Setting the `NativeFormat` paths on Windows and Mac OS X has no effect.

  Warning: This function doesn't affect existing `QSettings` objects.

  See Also:
    `registerFormat`

### fromNativePointer

    public static QSettings fromNativePointer(QNativePointer nativePointer)

  This function returns the QSettings instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD